using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace BitmapConverter
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private FileStream bmpFile;
        private byte[] bmpData;
        private System.Drawing.Image bmpImage;
        private System.Drawing.Bitmap bmp;

        private int targetHeight = 10;  // Height in Pixel
        private int targetWidth = 8;    // Width in Pixel
        int CharOffset = 32;            // Characters start at
        bool invers = true;            // Output Bits inverted
        string outFileName = @"D:\temp\output.inc";

        private void LoadBitmapfile(string filename)
        {
            bmpImage = Bitmap.FromFile(filename);
            listBox1.Items.Add("loaded: " + filename);
            listBox1.Items.Add(" Size: " + bmpImage.Size.ToString() + "  Depth: " + bmpImage.PixelFormat.ToString());

            outFileName = Path.ChangeExtension(filename, ".inc");
        }

        private void CreateIncludefile()
        {
            if (bmpImage == null)
                return;

            bmp = new Bitmap(bmpImage);
            int cols = bmp.Size.Width / targetWidth;
            int rows = bmp.Size.Height / targetHeight;
            StreamWriter sw = new StreamWriter(outFileName);

            int nBytes = cols * rows * targetHeight;
            int currentByte = 0;
            for (int r = 0; r < rows; r++)
            {
                for (int c = 0; c < cols; c++)
                {
                    int CharNo = CharOffset + r * cols + c;
                    sw.WriteLine("//// Char " + CharNo.ToString());
                    for (int br = 0; br < 10; br++)
                    {
                        currentByte++;
                        sw.Write("  0b");               // Write Def.Start
                        for (int b = 0; b < 8; b++)
                        {
                            Color pixelColor = bmp.GetPixel(c * targetWidth + b, r * targetHeight + br);
                            bool pixelOn = (pixelColor.ToArgb() != Color.Black.ToArgb());
                            if (pixelOn ^ invers)
                                sw.Write('1');
                            else
                                sw.Write('0');
                        }
                        if (currentByte < nBytes)
                            sw.WriteLine(",");
                    }
                }
            }
            sw.WriteLine();
            sw.Close();
        }

        private void openFileDialog1_FileOk(object sender, CancelEventArgs e)
        {
            LoadBitmapfile(openFileDialog1.FileName);
        }

        private void btnOpen_Click(object sender, EventArgs e)
        {
            DialogResult rs = openFileDialog1.ShowDialog();
        }

        private void btnCreate_Click(object sender, EventArgs e)
        {
            CreateIncludefile();
        }

    }
}